; Deco-1.0/theme.jl

;; A theme with an Art Deco feel, still
;; in its early stages.
;;
;; Copyright (C) Gavin McCord, 19 December 2000
;;
;; Adapted from the microGUI theme
;; Copyright (C) 1999 Ryan Lovett <ryan@ocf.berkeley.edu>

(let*
  (

;; (font (get-font "-bitstream-futura-medium-r-normal-medium-*-*-140-*-p-*-iso8859-1"))

;; (font (get-font "-bitstream-broadway-medium-r-normal--*-*-140-*-p-*-iso8859-1"))

;; (font (get-font "-bitstream-humanist 521-medium-r-normal--*-*-160-*-p-*-iso8859-1"))

    (font-colors (list "white" "#f5f0c0"))


    ;; Update window title pixel length
     (title-width
      (lambda (w)
	(let
	    ((w-width (car (window-dimensions w))))
	  (max 0 (min (- w-width 100) (text-width (window-name w)))))))

     ;; 4x9
     (bottom-images (list (make-image "bottom_inactive.png")
				(make-image "bottom_active.png")))

     ;; 21x25
     (top-left-images (list (make-image "top_left_inactive.png")
			    (make-image "top_left_active.png")))
     (top-left-shaped-images (list (make-image "top_left_inactive_s.png")
				   (make-image "top_left_active_s.png")))

     ;; 19x19
     (top-title-images (list (make-image "top_inactive.png")
			    (make-image "top_active.png")))

     ;; 21x25
     (top-right-images (list (make-image "top_right_inactive.png")
			(make-image "top_right_active.png")))
     (top-right-shaped-images (list (make-image "top_right_inactive_s.png")
			(make-image "top_right_active_s.png")))

     ;; 9x9
     (bottom-left-images (list (make-image "bottom_left_inactive.png")
				(make-image "bottom_left_active.png")))

     ;; 9x9
     (bottom-right-images (list (make-image "bottom_right_inactive.png")
				(make-image "bottom_right_active.png")))

     ;; 17x16
     (close-images (list (make-image "close_normal.png")
			 (make-image "close_active.png") nil
			 (make-image "close_clicked.png")))

     ;; 17x16
     (maximize-images (list (make-image "maximize_normal.png")
			    (make-image "maximize_active.png") nil
			    (make-image "maximize_clicked.png")))

     ;; 17x16
     (iconify-images (list (make-image "minimize_normal.png")
			   (make-image "minimize_active.png") nil
			   (make-image "minimize_clicked.png")))

     ;; 17x16
     (menu-images (list (make-image "menu_normal.png")
			(make-image "menu_active.png") nil
			(make-image "menu_clicked.png")))

     ;; 21x25
     (left-top-images (list (make-image "left_top_inactive.png")
			(make-image "left_top_active.png")))

     ;; 21x4
     (left-images (list (make-image "left_inactive.png")
			(make-image "left_active.png")))

     ;; 21x36
     (left-bottom-images (list (make-image "left_bottom_inactive.png")
			(make-image "left_bottom_active.png")))

     ;; 21x25
     (right-top-images (list (make-image "right_top_inactive.png")
                        (make-image "right_top_active.png")))

     ;; 6x19
     (right-images (list (make-image "right_inactive.png")
			(make-image "right_active.png")))

     ;; 21x36
     (right-bottom-images (list (make-image "right_bottom_inactive.png")
                        (make-image "right_bottom_active.png")))

     ;; 21x25
     (t-close-images (list (make-image "t_close_normal.png")
			   (make-image "t_close_active.png") nil
			   (make-image "t_close_clicked.png")))
     ;; 4x9
     (t-left-images (make-image "t_left.png"))

     ;; 4x9
     (t-right-images (make-image "t_right.png"))

     ;; 19x5
     (t-top-images (make-image "t_top.png"))

     ;; 4x25
     (t-bottom-images (make-image "t_bottom.png"))

     ;; 9x9
     (t-top-left-images (make-image "t_top_left.png"))

     ;; 21x25
     (t-bottom-left-images (make-image "t_bottom_left.png"))

     ;; 21x25
     (t-bottom-lefts-images (make-image "t_bottom_left_s.png"))

     ;; 9x9
     (t-top-right-images (make-image "t_top_right.png"))

     ;; 21x25
     (t-bottom-right-images (make-image "t_bottom_right.png"))

     ;; 21x25
     (t-bottom-rights-images (make-image "t_bottom_right_s.png"))

     ;; frame layout

     (frame `(((background . ,top-left-images)
	       (left-edge . -21)
	       (top-edge . -25)
	       (class . top-left-corner))

	      ;; top 
	      ((background . ,top-title-images)
	       (foreground . ,font-colors)
	       (text . ,window-name)
	       (x-justify . center)
	       (y-justify . center)
	       (top-edge . -25)
	       (left-edge . 21)
	       (right-edge . 52)
;;		(font . ,font)
		(class . title))

	      ;; menu button
	      ((background . ,menu-images)
	       (top-edge . -25)
	       (left-edge . 0)
	       (class . menu-button))

	      ;; left top
	      ((background . ,left-top-images)
	       (left-edge . -21)
	       (top-edge . 0)
	       (class . left-border))

	      ;; left border
	      ((background . ,left-images)
	       (left-edge . -21)
	       (top-edge . 25)
	       (bottom-edge . 36)
	       (class . left-border))

	      ;; left bottom
	      ((background . ,left-bottom-images)
		(left-edge . -21)
	        (bottom-edge . 0)
		(class . left-border))

	      ;; top-right corner
	      ((background . ,top-right-images)
	       (right-edge . -21)
	       (top-edge . -25)
	       (class . top-right-corner))

             ;; right top
              ((background . ,right-top-images)
               (right-edge . -21)
               (top-edge . 0)
               (class . right-border))

	      ;; right border
	      ((background . ,right-images)
	       (right-edge . -21)
	       (top-edge . 25)
	       (bottom-edge . 36)
	       (class . right-border))

              ;; right bottom
              ((background . ,right-bottom-images)
                (right-edge . -21)
                (bottom-edge . 0)
                (class . right-border))

	      ;; bottom border
	      ((background . ,bottom-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . -9)
	       (class . bottom-border))

	      ;; bottom-left corner
	      ((background . ,bottom-left-images)
	       (left-edge . -9)
	       (bottom-edge . -9)
	       (class . bottom-left-corner))

	      ;; bottom-right corner
	      ((background . ,bottom-right-images)
	       (right-edge . -9)
	       (bottom-edge . -9)
	       (class . bottom-right-corner))

	      ;; iconify button
	      ((background . ,iconify-images)
	       (right-edge . 42)
	       (top-edge . -25)
	       (class . iconify-button))

	      ;; maximize button
	      ((background . ,maximize-images)
	       (right-edge . 21)
	       (top-edge . -25)
	       (class . maximize-button))

	      ;; delete button
	      ((background . ,close-images)
	       (right-edge . 0)
	       (top-edge . -25)
	       (class . close-button))))

       (shaped-frame `(((background . ,top-left-shaped-images)
			(left-edge . -21)
			(top-edge . -25)
			(height . 25)
			(class . top-left-corner))

		       ;; top title
		       ((background . ,top-title-images)
			(foreground . ,font-colors)
			(text . ,window-name)
			(x-justify . center)
			(y-justify . center)
			(top-edge . -25)
			(left-edge . 21)
			(right-edge . 52)
;;			(font . ,font)
			(class . title))

		       ;; menu button
		       ((background . ,menu-images)
			(top-edge . -25)
			(left-edge . 0)
			(class . menu-button))

		       ;; top-right corner
		       ((background . ,top-right-shaped-images)
			(right-edge . -21)
			(top-edge . -25)
			(height . 25)
			(class . top-right-corner))

		       ;; iconify button
		       ((background . ,iconify-images)
			(right-edge . 42)
			(top-edge . -25)
			(class . iconify-button))

		       ;; maximize button
		       ((background . ,maximize-images)
			(right-edge . 21)
			(top-edge . -25)
			(class . maximize-button))

		       ;; delete button
		       ((background . ,close-images)
			(right-edge . 0)
			(top-edge . -25)
			(class . close-button))))

       (transient-frame `(((background . ,t-top-left-images)
			   (left-edge . -9)
			   (top-edge . -9)
			   (class . top-left-corner))

			  ;;top-right corner
			  ((background . ,t-top-right-images)
			   (right-edge . -9)
			   (top-edge . -9)
			   (class . top-right-corner))

			  ;;top border
			  ((background . ,t-top-images)
			   (left-edge . 0)
			   (right-edge . 0)
			   (top-edge . -9)
			   (class . top-border))

			  ;; left border
			  ((background . ,t-left-images)
			   (left-edge . -9)
			   (top-edge . 0)
			   (bottom-edge . 0)
			   (class . left-border))

			  ;; right border
			  ((background . ,t-right-images)
			   (right-edge . -9)
			   (top-edge . 0)
			   (bottom-edge . 0)
			   (class . title))

			  ;; bottom border
			  ((background . ,t-bottom-images)
               		   (foreground . "white")
               		   (x-justify . center)
			   (y-justify . center)
               		   (text . ,window-name)
			   (left-edge . 21)
			   (right-edge . 0)
			   (bottom-edge . -25)
;;			   (font . ,font)
			   (class . title))

			  ;; bottom-left corner
			  ((background . ,t-bottom-left-images)
			   (left-edge . -21)
			   (bottom-edge . -25)
			   (class . bottom-left-corner))

			  ;; bottom-right corner
			  ((background . ,t-bottom-right-images)
			   (right-edge . -21)
			   (bottom-edge . -25)
			   (class . bottom-right-corner))

			  ;; delete button
			  ((background . ,t-close-images)
			   (left-edge . 0)
			   (bottom-edge . -25)
			   (class . close-button))))

       (shaped-transient-frame `(((background . ,t-bottom-rights-images)
				  (right-edge . -21)
				  (bottom-edge . -25)
				  (class . bottom-right-corner))

				;; bottom border
				((background . ,t-bottom-images)
				 (foreground . "white")
				 (x-justify . center)
				 (y-justify . center)
				 (text . ,window-name)
				 (left-edge . 21)
				 (right-edge . 0)
				 (bottom-edge . -25)
;;				 (font . ,font)
				 (class . title))

				 ;; bottom-left corner
				 ((background . ,t-bottom-lefts-images)
				  (left-edge . -21)
				  (bottom-edge . -25)
				  (class . bottom-right-corner))

				 ;; delete button
				 ((background . ,t-close-images)
				  (left-edge . 0)
				  (bottom-edge . -25)
				  (class . close-button)))))
  
  (add-frame-style 'Deco-1.0
		   (lambda (w type)
		     (case type
		       ((default) frame)
		       ((transient) transient-frame)
		       ((shaped) shaped-frame)
		       ((shaped-transient) shaped-transient-frame))))

  (call-after-property-changed
   'WM_NAME (lambda ()
	      (rebuild-frames-with-style 'Deco-1.0))))
